#include <register.h>
#include <vcrt.h>
#include <macros.h>
#include <sysvar.h>

void enctest(void);
void sertest(void);
void usage(void);

#define IO_IOCTL_SERIAL_INBUF            (0x0201) // serial only!
#define IO_IOCTL_SERIAL_OUTBUF           (0x0202)


main(int argc, char * argv)
{
print("iftest4x version 1.0          Copyright Vision Components 2006\n");
print("TEST VC40xx I/O interface:  with new PWR_PCB > Version 1.3 !!!\n");
if(argc == 1 && strcmp(argv,"enc")==0 )  
enctest();
else
if(argc == 1 && strcmp(argv,"ser")==0 )  
sertest();
else
usage();  
}

void usage(void)
{
print("type 'iftest4x enc' => encoder     TEST\n");
print("type 'iftest4x ser' => serial I/O  TEST\n");
}

void sertest(void)
{
FILE *tty;
//unsigned xbaud=115200;
unsigned xbaud=9600;
char c=0;

print("\nSerial Interface Test press <ESC> to abort\n\n");

INTERFACE_MODE(SERIAL);

tty = fopen("kbd:", (void *)0);	/* open serial device */


print("Set baudrate=%d\n",xbaud);
io_ioctl(tty,IO_IOCTL_SERIAL_SET_BAUD,&xbaud);
xbaud=0;
io_ioctl(tty,IO_IOCTL_SERIAL_SET_FLAGS,&xbaud);

print("\nWriting 'abcdefg' to serial device !\n");
write(tty,"abcdefg",7);

print("\nAny typed char on serial device will be echoed!\n");
print("\nPress ESC on serial terminal to exit!\n");

while(c != 0x1b && rbempty()==-1)
{
  if(io_fstatus(tty)) // test if there are some chars in in buffer 
  {
	c=io_fgetc(tty);
	print("c=0x%x\n",c);
  if(c!=0x1b)
	{
	  {
		io_fputc(c, tty);
	  }
	}
  }
}

fclose(tty);	/* close serial device */

INTERFACE_MODE(ENCODER); // Encoder mode (RS232 disabled)

}

void enctest(void)
{
  int Run=1,i=0;
  char c;
  print("\nEncoder Interface Test, press <ESC> to abort\n\n");
  TRIGINP_NEG() ;		// turning direction anti clockwise
  tpict(); 				// take image to end live mode
  INTERFACE_MODE(ENCODER); // Encoder mode (RS232 disabled)
  ENC_DISABLE_CNT();    // disable counter
  //ENC_WAIT_N();         // wait one time for next 0+ pulse 
  ENC_WAIT_N_TRIG();    // wait every time for next 0+ pulse 
  ENC_ENABLE_CNT();     // enable inputs 
  ENC_WRITE_CNT(506);   // set Counter value
  ENC_WRITE_RELOAD(256);// set Reload value
  while(Run)
  	{
    tenable();      	// wait for external trigger and take picture
    while(!trdy())		// wait for image completion
    	{ 			
         if(kbhit())	// check for keyboard input
         	{
	         c=rs232rcv();
		     if(c==0x1B)	// check for "ESC"
		     	{	
		         while(cancel_capture_rq());
		         Run = 0;  // deleting last capture request
	            }		 
            }
	      printf("encodervalue is: %08d \r",ENC_READ_CNT());
	      wait(0,50); 	// 	waiting time to slow printing 
         }
  	 print("************* exposure ************** (%u)\n",i++);
     }
  INTERFACE_MODE(SERIAL);// Serial mode (RS232 enabled)
  vmode(0);				// swtiching camera back to live mode
}

